/**
 * JavaLearning.java  1.00 97/11/09 Manolo Caeiro
 *
 * http://helia.ait.uvigo.es/~mcaeiro   mcaeiro@helia.ait.uvigo.es
 */



/*
 * 1.0 code.
 */

package javaLearning2;


import java.awt.*;
import java.util.*;
import java.applet.Applet; 

import javaLearning2.examples.*;



public class JavaLearning extends Applet implements JLFrameWork {

  Applet applet; 

  Hashtable sourceCodes = new Hashtable ();
  Hashtable fileNames = new Hashtable ();
  Vector numberLines = new Vector ();
  Object actualObject = null;

  TextArea explainArea = new TextArea ("START", 5, 70);  
  TextArea sourceArea = new TextArea ("", 20, 80);  
  Label sourceLabel = new Label ("SOURCE CODE");

  private boolean waitvar;
  Object myThread;
  
  public void debugContinue() {
	  waitvar=false;	
	  synchronized (myThread) {
		myThread.notify();
	  }
  }
  
  public  void init () {    
 
    setLayout (new BorderLayout (10, 10));     
    
    ButtonPanel buttonPanel = new ButtonPanel (this);   
    // buttonPanel.setBackground (new Color (150, 150, 240));
    this.add ("North", buttonPanel); 
    
    Panel explainPanel = new Panel ();
    explainPanel.setLayout (new BorderLayout ());
    Label explainLabel = new Label ("JAVA LEARNING EXPLAIN");
    explainLabel.setBackground (new Color (150, 150, 240));
    explainLabel.setForeground (Color.white);
    explainArea.setBackground (new Color (150, 150, 185));
    explainArea.setForeground (Color.white);
    explainPanel.add ("North", explainLabel);
    explainPanel.add ("Center", explainArea);
    explainArea.setEditable (false);
    this.add ("West", explainPanel);
    
    
    Panel sourcePanel = new Panel ();
    sourcePanel.setLayout (new BorderLayout ()); 
    sourceLabel.setBackground (new Color (150, 150, 240));
    sourceLabel.setForeground (Color.white);
    sourceArea.setBackground (new Color (150, 150, 185));
    sourceArea.setForeground (Color.white);
    sourcePanel.add ("North", sourceLabel);
    sourcePanel.add ("Center", sourceArea);
    sourceArea.setEditable (false);
    this.add ("South", sourcePanel);
   
    applet = new Converter (this);
 
    this.add ("Center", applet); 
  
    validate ();  
    show ();

    applet.init (); 
  
  }
 

  public void start () {    
    applet.start ();
  } 

  public void paint (Graphics g) { 
    if (applet != null) applet.paint (g); 
  }
  
  public void setSourceCode (Object object, Vector code, String name) {
    sourceCodes.put (object, code);
    fileNames.put (object, name);
  }

  int initPoint = 0;

  public  void waitAtLine (Object object, int lineNumber) {
    System.out.println ("Waiting at line " + lineNumber);
 
    if ((actualObject == null) || (!actualObject.equals (object))) {
      actualObject = object;

      String fileName = (String) fileNames.get (object);
      sourceLabel.setText ("SOURCE CODE: " + fileName);

      Vector code = (Vector) sourceCodes.get (object);
      numberLines.removeAllElements ();
      sourceArea.setText ("");
       
      int position = 0;
      initPoint = 0;
      Enumeration codeLines = code.elements ();
	  String tempS= "";
      while (codeLines.hasMoreElements ()) {
			String actualLine = (String) codeLines.nextElement (); 
						  
			numberLines.addElement (new Integer (position));
			position += (actualLine.length () + 3);
			tempS += "  " + actualLine + "\n";
      }
	  sourceArea.appendText (tempS);
    } 
    else sourceArea.replaceRange ("   ", initPoint, initPoint + 3);

    initPoint = ((Integer) numberLines.elementAt (lineNumber)).intValue ();
    int endPoint = ((Integer) numberLines.elementAt (lineNumber+1)).intValue ();
    sourceArea.replaceRange ("==>", initPoint, initPoint + 3);
    sourceArea.select (initPoint,endPoint); 
    if (initPoint > 2) sourceArea.setCaretPosition (initPoint-1);


    validate (); 
 
    waitvar = true;
    
	myThread = new Object();
	
	try {
		while(waitvar) {
			synchronized (myThread) {
				myThread.wait (10000);  
			}
			System.out.println ("Despertando");
		}
	} catch (InterruptedException ie) {
      System.out.println ("JavaLearning. InterruptedException");
    }
	System.out.println ("Continuando...");
  }
     
  public void waitAMomentAtLine (Object object, int lineNumber) {
    System.out.println ("Waiting at line " + lineNumber);
 
    if ((actualObject == null) || (!actualObject.equals (object))) {
      actualObject = object;

      String fileName = (String) fileNames.get (object);
      sourceLabel.setText ("SOURCE CODE: " + fileName);

      Vector code = (Vector) sourceCodes.get (object);
      numberLines.removeAllElements ();
      sourceArea.setText ("");
       
      int position = 0;
      initPoint = 0;
      Enumeration codeLines = code.elements ();
      while (codeLines.hasMoreElements ()) {
	String actualLine = (String) codeLines.nextElement (); 
      
	numberLines.addElement (new Integer (position));
	position += (actualLine.length () + 3);
	sourceArea.appendText ("  " + actualLine + "\n");
      }
    } 
    else sourceArea.replaceRange ("   ", initPoint, initPoint + 3);

    initPoint = ((Integer) numberLines.elementAt (lineNumber)).intValue ();
    int endPoint = ((Integer) numberLines.elementAt (lineNumber+1)).intValue ();
    sourceArea.replaceRange ("==>", initPoint, initPoint + 3);
    sourceArea.select (initPoint,endPoint);
    if (initPoint > 2) sourceArea.setCaretPosition (initPoint-1);

    validate ();  
    
    
    try {  
	Thread.currentThread ().sleep (2000);   
    } catch (InterruptedException ie) {
      System.out.println ("JavaLearning. InterruptedException");
    }
  }

  public void addText (String text) {
    explainArea.appendText ("\n");
    explainArea.appendText (text);
  }
}
